'use strict';

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = stdoutToDemo;

var SourceMapConsumer = require('source-map').SourceMapConsumer;
var normalizeNewline = require('normalize-newline');
var getOutputs = require('./get-outputs');
var mergeCodeWithDemo = require('./merge-code-with-demo');

function stdoutToDemo(opts) {
  if (typeof opts === 'string') opts = { code: opts };
  opts.cwd = opts.cwd || process.cwd();
  opts.code = normalizeNewline(opts.code);

  return getOutputs(opts).then(function (outputs) {
    if (!opts.map) {
      return mergeCodeWithDemo({
        code: opts.code,
        outputs: outputs
      });
    }
    var consumer = new SourceMapConsumer(opts.map);
    var originalOutputs = outputs.map(function (output) {
      return (0, _assign2.default)({}, output, consumer.originalPositionFor({
        line: output.line,
        column: output.column
      }));
    });
    var sourcesContent = JSON.parse(opts.map).sourcesContent;
    var sourceContent = sourcesContent[sourcesContent.length - 1];
    return mergeCodeWithDemo({
      code: sourceContent,
      outputs: originalOutputs
    });
  });
}